import java.math.BigDecimal;
/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/* Präsentiert die Rechenaufgaben, bei denen die maximal mögliche Rahmengröße
 * bei der vorgegebenen Übertragungsgeschwindigkeit berechnet werden soll.
 */
public class AufgabeGrundR1 implements RechenAufgaben{
  Netzwerk netzwerk;
  String[] aufgabenStellung = new String[1];
  float loesung;
  int valuation = 0;
  MainFrame mainFrame;

  public AufgabeGrundR1(MainFrame mainFrame, Netzwerk netzwerk) {
    this. mainFrame = mainFrame;
    this.netzwerk = netzwerk;
    loesung = netzwerk.getÜbertragGeschwind()*10000/8; //10ms * 1000000 (Mega von MBit)
  }

  public String[] getAufgabenstellung() {
    aufgabenStellung[0] =
        "What is the maximum size per frame, if the data signaling rate is "+
        //" Wie groß darf ein Frame maximal sein, wenn Übertragungsgeschwindigkeit = " +
        netzwerk.getÜbertragGeschwind() +
        " MBit/s and Token Holding Time is 10 ms?";
        //" MBit/s und Token Holding Time = 10 ms?";
    return aufgabenStellung;
  }
  public float getSolution()
  /* Das Ergebnis ist in [Byte] */
  {
    return loesung;
  }

  public boolean check(String eingabe) throws EingabeException
  {
    int loes = (int) loesung;
    String ein = eingabe;
    if(ein.equals(""+loes))
    {
      valuation = 1;
      return true;
    }
    else
    {
      valuation = -1;
      throw new EingabeException("Sorry, incorrect answer");
    }
  }
  public int getValuation()
  {
    return valuation;
  }
  public String datenSenden(java.util.List SendParameter)
  {
    for (int i=0; i<SendParameter.size(); i++)
    {
      System.out.println(SendParameter.get(i));
    }
    results k1 = new results();
    k1.command ="ergeing";
    k1.appletid =(String)SendParameter.get(4);
    k1.id =(String)SendParameter.get(0);
    k1.password=(String)SendParameter.get(1);
    k1.difficulty=(String) SendParameter.get(2);
    k1.valuation = ""+valuation;

    k1.time =(String)SendParameter.get(3);
    k1.status();

    k1.destip = mainFrame.tokenRingTrainer.getDocumentBase().getHost();
    k1.destport = 3200;
    k1.send();
    k1.status();
    return k1.ok;
  }

}