
import javax.swing.*;
import java.awt.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/* Teil der GUI, in dem die Einstellungen für die Aufgabe
 * angezeigt werden
 */
public class Einstellungen extends JPanel {

  Netzwerk netzwerk;

  GridLayout gridLayout1 = new GridLayout(5,2);
  JLabel grundDaten_AnzStationen = new JLabel("Station count");
  JLabel _anzStationen = new JLabel();
  JLabel grundDaten_Datenrate = new JLabel("Data signaling rate");
  JLabel _datenrate = new JLabel();
  JLabel grundDaten_Entfernung = new JLabel("Distance between stations");
  JLabel _entfernung = new JLabel();
  JLabel grundDaten_Ausbreitgeschw = new JLabel("Signaling speed");
  JLabel _ausbreitGeschw = new JLabel();
  JLabel grundDaten_ActivMonitor = new JLabel("Active Monitor");
  JLabel _activMonitor = new JLabel();

  JPanel east = new JPanel();
  JPanel west = new JPanel();

  public Einstellungen() {
    this.setLayout(new BorderLayout());
    east.setLayout(new GridLayout(5,1));
    west.setLayout(new GridLayout(5,1));
    //this.setBorder(BorderFactory.createEmptyBorder(3,3,5,5));
    east.setBorder(BorderFactory.createEmptyBorder(3,3,5,5));
    west.setBorder(BorderFactory.createEmptyBorder(3,3,5,5));
    grundDaten_AnzStationen.setBorder(BorderFactory.createEmptyBorder(3,3,3,5));
    _anzStationen.setPreferredSize(new Dimension(60,5));
    _anzStationen.setBorder(BorderFactory.createBevelBorder(1));
    grundDaten_Datenrate.setBorder(BorderFactory.createEmptyBorder(3,3,3,5));
    _datenrate.setBorder(BorderFactory.createBevelBorder(1));
    _datenrate.setPreferredSize(new Dimension(60,5));
    grundDaten_Entfernung.setBorder(BorderFactory.createEmptyBorder(3,3,3,5));
    _entfernung.setBorder(BorderFactory.createBevelBorder(1));
    _entfernung.setPreferredSize(new Dimension(60,5));
    grundDaten_Ausbreitgeschw.setBorder(BorderFactory.createEmptyBorder(3,3,2,5));
    _ausbreitGeschw.setBorder(BorderFactory.createBevelBorder(1));
    grundDaten_ActivMonitor.setBorder(BorderFactory.createEmptyBorder(3,3,3,5));
    _activMonitor.setPreferredSize(new Dimension(60,5));
    _activMonitor.setBorder(BorderFactory.createBevelBorder(1));

 //   _ausbreitGeschw.setPreferredSize(new Dimension(60,5));

    west.add(grundDaten_AnzStationen);
    east.add(_anzStationen);
    west.add(grundDaten_Datenrate);
    east.add(_datenrate);
    west.add(grundDaten_Entfernung);
    east.add(_entfernung);
    west.add(grundDaten_Ausbreitgeschw);
    east.add(_ausbreitGeschw);
    west.add(grundDaten_ActivMonitor);
    east.add(_activMonitor);
    this.add(east, BorderLayout.EAST);
    this.add(west, BorderLayout.WEST);

  }

  public void setEinstellungen(Netzwerk netzwerk)
  {
    try
    {
      this.netzwerk = netzwerk;
    }
    catch(NullPointerException npe)
    {
      npe.printStackTrace();
    }

    _anzStationen.setText(""+netzwerk.getStationenListe().size());
    _datenrate.setText(netzwerk.getÜbertragGeschwind()+"MBit/s");
    if(netzwerk.getDifficulty() < 18)
    _entfernung.setText(((Verbindung)netzwerk.getVerbindungenListe().get(0)).getSize()+" m");
    _ausbreitGeschw.setText("<html>2*10<SUP>8</SUP> m/s</html>");
    if(netzwerk.getDifficulty() > 5)
    {
      for (int i = 0; i < netzwerk.getStationenListe().size(); i++) {
        if ( ( (Station) netzwerk.getStationenListe().get(i)).getActivMonitor())
          _activMonitor.setText( ( (Station) netzwerk.getStationenListe().get(i)).
                                getName());
      }
    }
  }

}