
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import viror.teach.anim.net.*;
import viror.teach.anim.*;
import javax.swing.*;
import java.net.*;
import java.util.Vector;


/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/* Zentrale Klasse der GUI.
 */
public class MainFrame
    extends JFrame {

  long zeitbedarf, zeitbedarf1;
  boolean angemeldet = false;
  int difficulty = 0;
  int errorCount = 0;

  String benutzerName = "";
  String kennwort = "";

  TokenRingTrainer tokenRingTrainer;
  NetzwerkErzeugen netzwerkErzeugen = new NetzwerkErzeugen();
  Netzwerk netzwerk;

  RechenAufgaben rechenAufgabe;
  TheorieAufgaben theorieAufgabe;

  boolean th = true, r = false;
  //t = theorie-, r = rechenaufgabe
  boolean[] aufg_Art = {
      th, r, r, th, r, th, r, th, r, r, th, r, th, r, th, r, th, r, th, r, th, r, th, r, th,
      r};
  boolean t = true, f = false;
  boolean[][][] buttons =
      {
      {
       {f,t,t,t,f,f,f,f,t,t,t,t,t,f,f,f,f,t,t},  //theorie für aufgabeErzeugen
       {f,f,f,t,f,f,f,f,f,f,f,f,f,f,f,f,f,f,t},  //theorie für testen1
       {t,f,f,f,t,f,f,f,f,f,f,f,f,f,f,f,f,f,t},  //theorie für senden1
       {f,f,f,f,f,t,f,t,f,f,f,f,f,f,f,f,f,f,t},  //theorie für start
       {f,f,f,f,f,f,t,t,f,f,f,f,f,f,f,f,f,f,t},  //theorie für pause
       {f,f,f,f,f,t,f,t,f,f,f,f,f,f,f,f,f,f,t},  //theorie für weiter
       {t,f,f,f,t,f,f,f,f,f,f,f,f,f,f,f,f,f,t},  //theorie für stop
       {f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,t}   //theorie für showSolution
      },
      {
       {f,f,t,t,f,f,f,f,f,f,f,f,f,f,f,t,f,t,f}, //rechen für aufgabeErzeugen
       {f,f,f,t,f,f,f,f,f,f,f,f,f,f,f,f,t,f,f}, //rechen für testen1
       {t,f,f,f,t,f,f,f,f,f,f,f,f,f,f,f,f,f,f}, //rechen für senden1
       {f,f,f,f,f,t,f,t,f,f,f,f,f,f,f,f,f,f,t}, //rechen für start
       {f,f,f,f,f,f,t,t,f,f,f,f,f,f,f,f,f,f,t}, //rechen für pause
       {f,f,f,f,f,t,f,t,f,f,f,f,f,f,f,f,f,f,t}, //rechen für weiter
       {t,f,f,f,t,f,f,f,f,f,f,f,f,f,f,f,f,f,t}, //rechen für stop
       {f,f,f,t,t,f,f,f,f,f,f,f,f,f,f,f,f,f,f}  //rechen für showSolution
      }
    };
/*   1. Dim:
   0: theorieAufgaben, 1: rechenAufgaben
   2. Dim:
   Reihenfolge der Buttons
   aufgabeErzeugen(0), testen1(1), senden1(2),
   start(3), pause(4), weiter(5), stop(6), showSolution(7)
   3. Dim:
   Reihenfolge der Buttons:
   aufgabeErzeugen(0), eingabeÜbernehmen(1), testen1(2), senden1(3),
   start(4), pause(5), weiter(6), stop(7), moveUp(8), moveDown(9),
   delete(10), stationen(11), aktionen(12), mitPrio(13), mitReserv(14), eingabeTextField(15),
   showSolution(16), skip(17), southCenterList(18)
   */
  Station posS;

  int startWiederholung = 0;

  JPanel contentPane;

  Einstellungen einstellungen;
  SendeStationenPanel centerWestCenterPanel = new SendeStationenPanel();
  JScrollPane westScroller;

  JPanel center = new JPanel();
  JPanel centerCenter = new JPanel();
  JPanel centerCenterCenter = new JPanel();
  JPanel centerCenterSouth = new JPanel();
  JPanel centerWest = new JPanel();
  JPanel centerWestCenter = new JPanel();
  JPanel centerWestCenterCenter = new JPanel();
  JPanel centerWestWest = new JPanel();
  JPanel centerWestNorth = new JPanel();
  JPanel centerWestNorthCenter = new JPanel();
  JPanel centerWestSouth = new JPanel();
  JPanel centerWestSouthNorth = new JPanel();
  JPanel centerWestSouthSouth = new JPanel();
  JPanel centerWestEast = new JPanel();

  TitledBorder einstellungenBorder;
  TitledBorder aufgabenStellungBorder;
  TitledBorder statusBorder;

  JPanel east = new JPanel();
  JPanel eastWest = new JPanel();
  JPanel eastCenter = new JPanel();
  JPanel eastCenter1 = new JPanel();
  JPanel eastCenter2 = new JPanel();
  JPanel eastCenter3 = new JPanel();
  JPanel eastCenter4 = new JPanel();
  JPanel eastCenter5 = new JPanel();
  JPanel eastEast = new JPanel();
  JPanel eastSouth = new JPanel();
  JLabel themaLabel = new JLabel();
  JLabel diffLabel = new JLabel();
  JLabel timeLabel = new JLabel();
  JLabel valuLabel = new JLabel();
  JPanel sendLabel = new JPanel();
  JLabel feedBackLabel = new JLabel();

  JPanel south = new JPanel();
  JPanel southSouth = new JPanel();
  JPanel southSouth1 = new JPanel();
  JPanel southSouth2 = new JPanel();
  JPanel southSouth3 = new JPanel();
  JPanel southSouth4 = new JPanel();
  JPanel southEast = new JPanel();
  JPanel southNorth = new JPanel();
  JPanel southWest = new JPanel();
  JPanel southWestNorth = new JPanel();
  JPanel southWestCenter = new JPanel();
  JPanel southWestCenter1 = new JPanel();
  JPanel southWestCenter2 = new JPanel();
  JPanel southWestCenter21 = new JPanel();
  JPanel southWestCenter22 = new JPanel();

  JPanel southWestSouth = new JPanel();
  JPanel southCenter = new JPanel();
  JPanel southCenterEast = new JPanel();
  JPanel southCenterEast1 = new JPanel();
  JPanel southCenterEast2 = new JPanel();
  JPanel southCenterEast3 = new JPanel();
  JPanel southCenterSouth = new JPanel();
  JPanel southCenterSouth1 = new JPanel();
  JPanel southCenterSouth2 = new JPanel();
  JLabel rSoluLabel = new JLabel("Solution");
  JLabel rtimeLabel = new JLabel("");
  JLabel rmsecLabel = new JLabel("");
  JPanel richtigOderFalsch = new JPanel();
  JTextField eingabeTextField = new JTextField(10);

  Vector eingabeTheorie = new Vector();
  JList southCenterList = new JList();
  EingabeListCellRenderer listCellRenderer = new EingabeListCellRenderer();
  DefaultListModel listModel = new DefaultListModel();
  JScrollPane scrollPaneForList = new JScrollPane(southCenterList);

  JPanel north = new JPanel();
  JPanel northPanel = new JPanel();
  JPanel northCenter = new JPanel();
  JPanel northWest = new JPanel();
  JPanel northEast = new JPanel();
  JButton aufgabeErzeugen = new JButton("<html><b>New Exercise</b></html>");
  JButton skip = new JButton("<html><b>>></b></html>");

  JButton eingabeÜbernehmen = new JButton("Add");
  JComboBox aktionen = new JComboBox();
  JComboBox stationen = new JComboBox();
  JComboBox prio = new JComboBox();
  JComboBox reservierung = new JComboBox();
  JLabel mitPrio = new JLabel("with P = ");
  JLabel mitReserv = new JLabel("and R = ");
  JLabel statusBar = new JLabel();
  JButton moveUp = new JButton();
  JButton moveDown = new JButton();
  JButton delete = new JButton();

  JButton testen1 = new JButton("Test");
  JButton senden1 = new JButton("Send");
  JButton showSolution = new JButton("Show Solution");

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel aufgabenStellung = new JPanel();

  /* Animationskomponeten */
  SimpleAnimList AList;
  AnimDisplay Display;
  Link[] linkListe;
  Router[] stationenListe;
  InternalLink[] internalLinkListe;
  boolean animation = false;

  JButton start = new JButton("Start");
  JButton pause = new JButton("Pause");
  JButton weiter = new JButton("Continue");
  JButton stop = new JButton("Stop");

  String loesungR = new String();

  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenuItem jMenuFileNew = new JMenuItem();
  JMenuItem jMenuFileRestart = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JToolBar jToolBar = new JToolBar();

  OnlineHilfeDialog dialog;


  //Construct the frame
  public MainFrame(TokenRingTrainer tokenRingTrainer, boolean angemeldet) {
    this.angemeldet = angemeldet;
    this.tokenRingTrainer = tokenRingTrainer;
    this.dialog = new OnlineHilfeDialog(this);
    einstellungen = new Einstellungen();
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {

    contentPane = (JPanel)this.getContentPane();
    contentPane.setLayout(borderLayout1);
    contentPane.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    this.setTitle("Aufgabe");
    this.setSize(Toolkit.getDefaultToolkit().getScreenSize());

    jMenuFile.setText("File");
    jMenuFileNew.setText("New Exercise");
    jMenuFileNew.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        aufgabeErzeugen();
        setButtons(0);
      }
    });
/*
    jMenuFileRestart.setText("Applet restart");
    jMenuFileRestart.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try
        {
        }
        catch(Exception ex)
        {
          ex.printStackTrace();
        }
      }
    });
*/

    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new MainFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new MainFrame_jMenuHelpAbout_ActionAdapter(this));

    jMenuFile.add(jMenuFileNew);
//    jMenuFile.add(jMenuFileRestart);
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);

    aufgabeErzeugen.setEnabled(true);
    eingabeÜbernehmen.setEnabled(false);
    testen1.setEnabled(false);
    start.setEnabled(false);
    weiter.setEnabled(false);
    stop.setEnabled(false);
    pause.setEnabled(false);
    stationen.setEnabled(false);
    aktionen.setEnabled(false);
    moveUp.setEnabled(false);
    moveDown.setEnabled(false);
    delete.setEnabled(false);
    senden1.setEnabled(false);
    testen1.setEnabled(false);
    eingabeTextField.setEditable(false);
    showSolution.setVisible(false);

    skip.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        AList.resumeAnim();
        aufgabeErzeugen();
        setButtons(0);
      }
    });

    aufgabeErzeugen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        AList.resumeAnim();
        aufgabeErzeugen();
        setButtons(0);
      }
    });

    start.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        listModel.clear();
        AList.resumeAnim();
        animationStarten();
        setButtons(3);
      }
    });

    eingabeÜbernehmen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        eingabeÜbernehmen();
      }
    });

    aktionen.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if ( (difficulty > 10) &&
            ( ( (String) e.getItem()).equals("generates a new priotoken")
             || ( (String) e.getItem()).equals("receives a priotoken")
             || ( (String) e.getItem()).equals("receives its own frame")
             || ( (String) e.getItem()).equals("transmits its own frame")
             )) {
          mitPrio.setVisible(true);
          mitPrio.setEnabled(true);
          prio.setVisible(true);
          prio.setEnabled(true);
          mitReserv.setVisible(true);
          mitReserv.setEnabled(true);
          reservierung.setVisible(true);
          reservierung.setEnabled(true);
        }
        else {
          if ( ( (String) e.getItem()).equals("sets the reservation bits")) {
            mitReserv.setText("R = ");
            mitReserv.setVisible(true);
            reservierung.setVisible(true);
            reservierung.setEnabled(true);
            mitPrio.setVisible(false);
            prio.setVisible(false);
            prio.setEnabled(false);
          }
          else {
            mitReserv.setText("and R = ");
            mitPrio.setVisible(false);
            prio.setVisible(false);
            prio.setEnabled(false);
            mitReserv.setVisible(false);
            reservierung.setVisible(false);
            reservierung.setEnabled(false);
          }
        }
      }
    });

    stop.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        AList.suspendAnim();
        animation = false;
        setButtons(6);
      }
    });

    pause.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        AList.suspendAnim();
        setButtons(4);
      }
    });

    weiter.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        AList.resumeAnim();
        setButtons(5);
      }
    });

    moveUp.setToolTipText("Move up");
    moveUp.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        int i = southCenterList.getSelectedIndex();
        if (i > 0) {
          Object obj = listModel.remove(i);
          listModel.add(i - 1, obj);
          theorieAufgabe.removeEingabe(i);
          theorieAufgabe.addEingabe(obj.toString(), i - 1);
          southCenterList.setSelectedIndex(i - 1);
        }
      }
    });
    Icon up = new ImageIcon(MainFrame.class.getResource(
        "UpMeins.gif"));
    moveUp.setIcon(up);
    moveUp.setPreferredSize(new Dimension(2*up.getIconWidth(), 2*up.getIconHeight()));

    moveDown.setToolTipText("Move down");
    moveDown.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        int i = southCenterList.getSelectedIndex();
        if (i >= 0 && i < listModel.size() - 1) {
          Object obj = listModel.remove(i);
          listModel.add(i + 1, obj);
          theorieAufgabe.removeEingabe(i);
          theorieAufgabe.addEingabe(obj.toString(), i + 1);
          southCenterList.setSelectedIndex(i + 1);
        }

      }
    });
    Icon down = new ImageIcon(MainFrame.class.getResource(
        "DownMeins.gif"));
    moveDown.setIcon(down);
    moveDown.setPreferredSize(new Dimension(2*down.getIconWidth(), 2*down.getIconHeight()));

    delete.setToolTipText("Delete");
    delete.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        int i = southCenterList.getSelectedIndex();
        if (i >= 0) {
          listModel.remove(i);
          theorieAufgabe.removeEingabe(i);
        }

      }
    });
    Icon del = new ImageIcon(MainFrame.class.getResource(
        "DeleteMeins.gif"));
    delete.setIcon(del);
    delete.setPreferredSize(new Dimension(2*down.getIconWidth(), 2*down.getIconHeight()));

    senden1.setPreferredSize(new Dimension(100,25));
    senden1.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        datenSenden();
        setButtons(2);
      }
    });

    showSolution.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        richtigOderFalsch.removeAll();
        eingabeTextField.setText(""+rechenAufgabe.getSolution());
        setButtons(7);
      }
    });
    Font font = new Font("myStyle", Font.BOLD, 12);

    east.setLayout(new BorderLayout());
    statusBorder = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,
        Color.white, new Color(142, 142, 142)), " Status ");
    statusBorder.setTitleFont(font);
    east.setBorder(statusBorder);

    eastCenter.setLayout(new GridLayout(5, 1));
    eastCenter1.add(themaLabel);
    FlowLayout eastCenter1layout = new FlowLayout();
    eastCenter1layout.setAlignment(FlowLayout.LEFT);
    eastCenter1.setLayout(eastCenter1layout);
    diffLabel.setHorizontalAlignment(JLabel.LEFT);
    eastCenter.add(eastCenter1);
    eastCenter2.add(diffLabel);
    FlowLayout eastCenter2layout = new FlowLayout();
    eastCenter2layout.setAlignment(FlowLayout.LEFT);
    eastCenter2.setLayout(eastCenter2layout);
    diffLabel.setHorizontalAlignment(JLabel.LEFT);
    eastCenter.add(eastCenter2);
    FlowLayout eastCenter3layout = new FlowLayout();
    eastCenter3layout.setAlignment(FlowLayout.LEFT);
    eastCenter3.setLayout(eastCenter3layout);
    eastCenter3.add(timeLabel);
    timeLabel.setHorizontalAlignment(JLabel.LEFT);
    eastCenter.add(eastCenter3);
    FlowLayout eastCenter4layout = new FlowLayout();
    eastCenter4layout.setAlignment(FlowLayout.LEFT);
    eastCenter4.setLayout(eastCenter4layout);
    eastCenter4.add(valuLabel);

    valuLabel.setHorizontalAlignment(JLabel.LEFT);
    eastCenter.add(eastCenter4);
    FlowLayout eastCenter5layout = new FlowLayout();
    eastCenter5layout.setAlignment(FlowLayout.LEFT);
    eastCenter5.setLayout(eastCenter5layout);
    eastCenter5.add(feedBackLabel);
    feedBackLabel.setHorizontalAlignment(JLabel.LEFT);
    eastCenter.add(eastCenter5);

    east.setPreferredSize(new Dimension(120, 0));
    east.add(eastCenter, BorderLayout.NORTH);
    contentPane.add(east, BorderLayout.EAST);

    north.setLayout(new BorderLayout());
    north.setPreferredSize(new Dimension(this.getWidth(), 110));
    aufgabenStellungBorder = new TitledBorder(new EtchedBorder(EtchedBorder.
        RAISED,
        Color.white, new Color(142, 142, 142)), " Exercise ");
    aufgabenStellungBorder.setTitleFont(font);
    north.setBorder(aufgabenStellungBorder);
    aufgabenStellung.setBackground(Color.LIGHT_GRAY);
    northCenter.add(aufgabenStellung);

    north.add(northCenter, BorderLayout.CENTER);
    northEast.setLayout(new GridLayout(2,1));
    north.add(northEast, BorderLayout.EAST);
    contentPane.add(north, BorderLayout.NORTH);

    center.setLayout(new BorderLayout());
    AList = new SimpleAnimList();
    Display = new AnimDisplay(AnimDisplay.SQUARE, 650, 650, AList);
    Display.setScreenUsage(0.16);
    centerCenter.setLayout(new BorderLayout());
    centerCenterCenter.add(Display);
    centerCenterSouth.add(start);
    centerCenterSouth.add(pause);
    centerCenterSouth.add(weiter);
    centerCenterSouth.add(stop);

    centerCenter.add(centerCenterCenter, BorderLayout.CENTER);
    centerCenter.add(centerCenterSouth, BorderLayout.SOUTH);
    center.add(centerCenter, BorderLayout.CENTER);
    contentPane.add(center, BorderLayout.CENTER);

    south.setLayout(new BorderLayout());
    southCenter.setLayout(new BorderLayout());
    southCenter.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
    southCenterList.setCellRenderer(listCellRenderer);
    scrollPaneForList.getViewport().setView(southCenterList);
    southCenterList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    southCenterList.setModel(listModel);

    southCenter.setPreferredSize(new Dimension(Display.getWidth(), 250));
    southCenter.add(scrollPaneForList, BorderLayout.CENTER);
    southCenterEast.setLayout(new GridLayout(3, 1));
    southCenterEast.add(southCenterEast1);
    southCenterEast.add(southCenterEast2);
    southCenterEast.add(southCenterEast3);
    southCenterEast1.add(moveUp);
    southCenterEast2.add(moveDown);
    southCenterEast3.add(delete);
    southCenter.add(southCenterEast, BorderLayout.EAST);
    south.add(southCenter, BorderLayout.CENTER);
    stationen.setPreferredSize(new Dimension(40, 25));
    aktionen.setPreferredSize(new Dimension(245, 25));
    mitPrio.setVisible(false);
    prio.setPreferredSize(new Dimension(40, 25));
    prio.setEnabled(false);
    mitReserv.setVisible(false);
    reservierung.setPreferredSize(new Dimension(40, 25));
    reservierung.setEnabled(false);

    FlowLayout southCenterSouthlayout = new FlowLayout();
    southCenterSouthlayout.setAlignment(FlowLayout.LEFT);
    southCenterSouth.setLayout(southCenterSouthlayout);

    southCenterSouth.add(stationen);
    southCenterSouth.add(aktionen);
    southCenterSouth.add(mitPrio);
    southCenterSouth.add(prio);
    southCenterSouth.add(mitReserv);
    southCenterSouth.add(reservierung);
    southCenterSouth.add(eingabeÜbernehmen);

    southCenter.add(southCenterSouth, BorderLayout.SOUTH);
    southCenter.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));

    south.add(southCenter, BorderLayout.CENTER);
    Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
    southWest.setPreferredSize(new Dimension((int)(dim.getWidth()*0.27), (int)(dim.getHeight()*0.20)));
    southWest.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
    southWest.setLayout(new BorderLayout());
    southWestNorth.add(rSoluLabel);
    southWest.add(southWestNorth, BorderLayout.NORTH);
    southWestCenter.setLayout(new GridLayout(2,1));
    southWestCenter.add(southWestCenter1);
    southWestCenter.add(southWestCenter2);
    southWestCenter1.add(rtimeLabel);
    southWestCenter1.add(eingabeTextField);
    southWestCenter1.add(rmsecLabel);
    southWestCenter2.setLayout(new GridLayout(2,1));
    southWestCenter2.add(southWestCenter21);
    southWestCenter21.add(richtigOderFalsch);
    southWestCenter2.add(southWestCenter22);
    southWest.add(southWestCenter, BorderLayout.CENTER);
    south.add(southWest, BorderLayout.WEST);

    southEast.setPreferredSize(new Dimension((int)(dim.getWidth()*0.12), (int)(dim.getHeight()*0.20)));
    southEast.add(sendLabel);

    south.add(southEast, BorderLayout.EAST);

    south.add(southSouth, BorderLayout.SOUTH);
    southSouth.setLayout(new GridLayout(1,4));
    southSouth.add(southSouth1);
    southSouth.add(southSouth2);
    southSouth.add(southSouth3);
    southSouth.add(southSouth4);
    southSouth1.add(aufgabeErzeugen);
    southSouth2.add(testen1);
    southSouth3.add(showSolution);
    southSouth4.add(senden1);

    contentPane.add(south, BorderLayout.SOUTH);

    centerWest.setLayout(new BorderLayout());
    einstellungenBorder = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,
        Color.white, new Color(142, 142, 142)), " Settings ");
    einstellungenBorder.setTitleFont(font);

    centerWestNorth.setLayout(new BorderLayout());
    einstellungen.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    centerWestNorth.add(einstellungen, BorderLayout.NORTH);
    centerWest.add(centerWestNorth, BorderLayout.NORTH);
    centerWest.setBorder(einstellungenBorder);
    westScroller = new JScrollPane(centerWestCenterPanel);
    centerWestCenter.setLayout(new BorderLayout());
    centerWestCenter.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    centerWestCenter.add(westScroller, BorderLayout.CENTER);
    centerWest.add(centerWestCenter, BorderLayout.CENTER);
    testen1.setPreferredSize(new Dimension(100,25));
    testen1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        zeitbedarf1 = System.currentTimeMillis() - zeitbedarf;
        timeLabel.setText("Time = "+zeitbedarf1/1000 +" sec");
        setButtons(1);
        eingabePrüfen();
      }
    });

    center.add(centerWest, BorderLayout.WEST);

    NetworkSemantics.getSemantics().initFromURL(new URL(tokenRingTrainer.
        getCodeBase(), "Semantics.properties"), tokenRingTrainer);
    AList.start();

  }

  public void setUpDisplay() {
    AList.removeAll();
    NetworkSemantics sem = NetworkSemantics.getSemantics();
    Image ringSchnittstelle = sem.getImage("SImA");
    Image aktiverMonitor = sem.getImage("SImB");
    Image station = sem.getImage("SImC");
    int n = netzwerk.getStationenListe().size();
    int containerWidth = Display.getGrid().width;
    int containerHeight = Display.getGrid().height;
    int xradius = (containerWidth -
                   3 * ringSchnittstelle.getWidth(tokenRingTrainer)) / 2;
    int yradius = (containerHeight -
                   3 * ringSchnittstelle.getWidth(tokenRingTrainer)) / 2;
    int xcenter = containerWidth / 2 + 20;
    int ycenter = containerHeight / 2 + 15;
    stationen.removeAllItems();
    for (int i = 0; i < n; i++) {
      double angle = 2 * Math.PI * i / n;
      int x = xcenter + (int) (Math.cos(angle) * xradius);
      int y = ycenter + (int) (Math.sin(angle) * yradius);

      if ( ( (Station) netzwerk.getStationenListe().get(i)).getActivMonitor()) {
        Station st = (Station) netzwerk.getStationenListe().get(i);
        stationenListe[i] = new Router(sem.getImage("SIm" + st.getName()),
                                       sem.getImage("SIm" + st.getName()),
                                       x - (ringSchnittstelle.getWidth(tokenRingTrainer)/2),
                                       y - (ringSchnittstelle.getWidth(tokenRingTrainer)/2));
        stationenListe[i].scalePeer(1.5);
        stationenListe[i].setHostname( ( (Station) netzwerk.getStationenListe().
                                        get(i)).getName());
        stationenListe[i].setHandler(new RahmenHandler(netzwerk,
            stationenListe[i], (Station) netzwerk.getStationenListe().get(i), this,
            sem));
        AList.addElement(3, stationenListe[i]);
        stationen.addItem(stationenListe[i].getHostname());
      }
      else {
        Station st = (Station) netzwerk.getStationenListe().get(i);
        stationenListe[i] = new Router(sem.getImage("SIm" + st.getName()),
                                       sem.getImage("SIm" + st.getName()),
                                       x - (ringSchnittstelle.getWidth(tokenRingTrainer)/2),
                                       y - (ringSchnittstelle.getWidth(tokenRingTrainer)/2));
        stationenListe[i].scalePeer(1.5);
        stationenListe[i].setHostname( ( (Station) netzwerk.getStationenListe().
                                        get(i)).getName());
        stationenListe[i].setHandler(new RahmenHandler(netzwerk,
            stationenListe[i], (Station) netzwerk.getStationenListe().get(i), this,
            sem));
        AList.addElement(3, stationenListe[i]);
        stationen.addItem(stationenListe[i].getHostname());
      }

      if (i != 0) {
        linkListe[i - 1] = new Link();
        linkListe[i - 1].setStart(stationenListe[i - 1]);
        linkListe[i - 1].setEnd(stationenListe[i]);
        linkListe[i - 1].generateRepresentation();
        AList.addElement(0, linkListe[i - 1]);
      }
      if (i == (n - 1)) {
        linkListe[i] = new Link();
        linkListe[i].setStart(stationenListe[i]);
        linkListe[i].setEnd(stationenListe[0]);
        linkListe[i].generateRepresentation();
        AList.addElement(0, linkListe[i]);
      }
    }
    AList.setFrameRate(10);
  }

  public void eingabeÜbernehmen() {
    String eingabe = stationen.getSelectedItem() + " " +
                         aktionen.getSelectedItem()
                         + (prio.isEnabled() ?
                          " with P = " + prio.getSelectedItem() + " and" : "")
                         + (reservierung.isEnabled() ?
                          " R = " + reservierung.getSelectedItem() : "");

    listModel.addElement(eingabe);
    theorieAufgabe.addEingabe(eingabe);
  }

  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
  //  System.exit(0);
  AList.resumeAnim();
  this.dispose();
  tokenRingTrainer.stop();
  }

  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  public void aufgabeErzeugen() {
    zeitbedarf = 0;
    timeLabel.setText("");
    valuLabel.setText("");
    feedBackLabel.setText("");
    eingabeTextField.setText("");
    richtigOderFalsch.setForeground(Color.BLACK);
    richtigOderFalsch.removeAll();
    rtimeLabel.setText("");
    rmsecLabel.setText("");
    if(errorCount == 0)
    {
      difficulty++;
      errorCount = 0;
    }
    if(difficulty <= 5)
    {
      themaLabel.setText("Token Passing");
    }
    if(difficulty > 5 && difficulty <= 9)
    {
      themaLabel.setText("Monitoring");
    }
    if(difficulty > 10)
    {
      themaLabel.setText("Priority");
    }
    startWiederholung = 0;
    eingabeTheorie.removeAllElements();
    listModel.clear();
    diffLabel.setText("Difficulty = " + difficulty);
    netzwerk = netzwerkErzeugen.erzeugeNetz(difficulty);
    posS = (Station) netzwerk.getRahmen().getPosition();
    if (difficulty == 2) {
      rtimeLabel.setText("Frame size:");
      rmsecLabel.setText("Byte");
      aufgabenStellung.removeAll();
      rechenAufgabe = new AufgabeGrundR1(this, netzwerk);
      aufgabenStellung.add(Utilities.createMultilineLabel(rechenAufgabe.
          getAufgabenstellung()[0]));
      loesungR = "" + rechenAufgabe.getSolution();
      System.out.println(loesungR);
    }
    if (difficulty == 3) {
      rtimeLabel.setText("Ring capacity:");
      rmsecLabel.setText("Bits");
      aufgabenStellung.removeAll();
      rechenAufgabe = new AufgabeGrundR2(this, netzwerk);
      aufgabenStellung.add(Utilities.createMultilineLabel(rechenAufgabe.
          getAufgabenstellung()[0]));
      loesungR = "" + rechenAufgabe.getSolution();
      System.out.println(loesungR);
    }
    int diff2 = difficulty;
    if (diff2 > 25) {
      diff2 = 25;
    }
    if (aufg_Art[diff2 - 1]) {
      listCellRenderer.setTest(false);
      aktionen.removeAllItems();
      theorieAufgabe = new TheorieAufgaben(this, netzwerk, diff2);
      String[] theorieVorlage = theorieAufgabe.getTheorieText(difficulty);
      for (int i = 0; i < theorieVorlage.length; i++) {
        aktionen.addItem(theorieVorlage[i]);
      }
      aktionen.repaint();
      aufgabenStellung.removeAll();
      String[] theorieAufgabenstellung = theorieAufgabe.getAufgabenStellung();

      aufgabenStellung.add(Utilities.createMultilineLabel("" +
          theorieAufgabenstellung[0] +
          theorieAufgabenstellung[1] +
          theorieAufgabenstellung[2] +
          theorieAufgabenstellung[3] +
          theorieAufgabenstellung[4] +
          theorieAufgabenstellung[5]));

      stationen.setEnabled(true);
      aktionen.setEnabled(true);
      eingabeÜbernehmen.setEnabled(true);
    }
    if (!aufg_Art[difficulty - 1]) {
      if (difficulty > 3) {
        rtimeLabel.setText("Time:");
        rmsecLabel.setText("msec");
        rechenAufgabe = new ZeitRechenAufgaben(this, netzwerk);
        String[] aufgabenStellungsText = rechenAufgabe.getAufgabenstellung();
        aufgabenStellung.removeAll();
        aufgabenStellung.add(Utilities.createMultilineLabel("" +
            aufgabenStellungsText[0] +
            aufgabenStellungsText[1] +
            aufgabenStellungsText[2] +
            aufgabenStellungsText[3] + " " +
            posS.getName() +
            aufgabenStellungsText[4]+
            aufgabenStellungsText[5]+
            aufgabenStellungsText[6]+
            aufgabenStellungsText[7]));

      }
      stationen.setEnabled(false);
      aktionen.setEnabled(false);
      mitPrio.setVisible(false);
      prio.setEnabled(false);
      mitReserv.setVisible(false);
      reservierung.setEnabled(false);
      eingabeÜbernehmen.setEnabled(false);
    }
    einstellungen.setEinstellungen(netzwerk);
    centerWestCenterPanel.setSendeStationen(netzwerk);
    linkListe = new Link[netzwerk.getStationenListe().size()];
    stationenListe = new Router[netzwerk.getStationenListe().size()];
    internalLinkListe = new InternalLink[netzwerk.getStationenListe().size()];

    if (difficulty == 1 || difficulty > 3) {
      netzwerk.startTimer();
      TokenRingManager tokenRingThread = new TokenRingManager(netzwerk);
      tokenRingThread.start();
    }
    if (difficulty > 10) {
      prio.removeAllItems();
      reservierung.removeAllItems();

      int maxPrio = 0;
      for (int i = 0; i < netzwerk.getGlobalPDUqueue().size(); i++) {
        if (maxPrio < ( (PDU) netzwerk.getGlobalPDUqueue().get(i)).getPriority()) {
          maxPrio = ( (PDU) netzwerk.getGlobalPDUqueue().get(i)).getPriority();
        }
      }
      for (int i = 0; i < maxPrio + 1; i++) {
        prio.addItem("" + i);
        reservierung.addItem("" + i);
      }
    }
    setUpDisplay();
    zeitbedarf = System.currentTimeMillis();
  }

  public void animationStarten() {

//    if(startWiederholung != 0)
    animation = true;
    listCellRenderer.setTest(false);

    if(startWiederholung != 0) //Erneuter Start
    {
      netzwerk.getRahmen().reset();
      netzwerk.getRahmen().setPosition(posS);
      setUpDisplay();
    }

    startWiederholung ++;

    for (int i = 0; i < netzwerk.getStationenListe().size(); i++) {
      Station st = (Station) netzwerk.getStationenListe().get(i);
      st.pduNeuInitialisieren();
      st.setTheorie(aufg_Art[netzwerk.getDifficulty()-1]);
    }
    NetworkSemantics sem = NetworkSemantics.getSemantics();
    Image token = sem.getImage("Token");
    viror.teach.anim.net.Package p = null;

    try {
      p = new viror.teach.anim.net.Package(0, 4, token, token);
      p.scalePeer(1.5);
      AList.addElement(0, p);
    }
    catch (java.beans.PropertyVetoException e) {
      System.err.println("Oh_dear_"); // should be impossible!
    }

    int j = 0;
    int k = 0;
    for (int i = 0; i < netzwerk.getStationenListe().size(); i++) {
      Station st = (Station) netzwerk.getStationenListe().get(i);
      if (st.getName().equals(posS.getName())) {
        j = netzwerk.getStationenListe().indexOf(st.getPredecessor());
        k = i;
      }
    }

    for (int i = 0; i < linkListe.length; i++) {
      if (linkListe[i].getEnd() == stationenListe[k]) {
        p.setTravelTime(20);
        linkListe[i].placePackage(stationenListe[j], p);
      }
    }
  }

  public Router[] getStationenListe() {
    return stationenListe;
  }

  public void addAusgabeText(final Vector text) {
    for (int i = 0; i < text.size(); i++) {
      eingabeTheorie.add( (String) text.get(i));
    }
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        for (int i = 0; i < text.size(); i++) {
          listModel.addElement( (String) text.get(i));
        }
      }
    });
  }

  public void eingabePrüfen() {
    if (aufg_Art[difficulty - 1]) {
      int index = southCenterList.getSelectedIndex();
      listCellRenderer.setTest(true);
      Vector check = theorieAufgabe.check();
      int[] testArray = new int[check.size()];
      listModel.clear();
      for (int i = 0; i < check.size(); i++) {
        int rof = ( (theorieZeile) check.get(i)).check;
        testArray[i] = rof;
      }
      listCellRenderer.setTestArray(testArray);
      for(int i = 0; i < check.size(); i++)
      {
        String ersatz = ( (theorieZeile) check.get(i)).eingabe;
        listModel.add(i, ersatz);
      }
      int[] selectedIndizes = new int[testArray.length];
      for(int i = 0; i < selectedIndizes.length; i++)
        selectedIndizes[i] = i;
      southCenterList.setSelectedIndices(selectedIndizes);
      southCenterList.setSelectedIndex(index);
      valuLabel.setText("Valuation = "+theorieAufgabe.getValuation());
      if(theorieAufgabe.getValuation() == 1)
        errorCount = 0;
        else
          errorCount++;
    }
    else
    {
      if(eingabeTextField.getText().toCharArray().length != 0)
      {
        String eingabe = eingabeTextField.getText();
        try {
          if (rechenAufgabe.check(eingabe)) {
            richtigOderFalsch.removeAll();
            richtigOderFalsch.setForeground(Color.GREEN);
            richtigOderFalsch.add(new Label("Right"));
            errorCount = 0;
          }
        }
        catch(EingabeException ee)
        {
          richtigOderFalsch.removeAll();
          richtigOderFalsch.setForeground(Color.RED);
          richtigOderFalsch.add(Utilities.createMultilineLabel(ee.getText(), Color.BLACK, 30));
          if(ee.getText().equals("Sorry, incorrect answer"))
            errorCount++;
            else
              setButtons(0);
          }
      }
      else
      {
        richtigOderFalsch.removeAll();
        richtigOderFalsch.setForeground(Color.RED);
        richtigOderFalsch.add(new Label("Please enter value!"));
        setButtons(0);
      }
       valuLabel.setText("Valuation = "+rechenAufgabe.getValuation());
      }
  }

  public void datenSenden()
  {
    if(angemeldet)
    {
      java.util.List sendParameter = new java.util.ArrayList();
      sendParameter.add(benutzerName);
      sendParameter.add(kennwort);
      sendParameter.add("" + netzwerk.getDifficulty());
      sendParameter.add("" + zeitbedarf1);
      sendParameter.add("TokenRing");
      if (aufg_Art[netzwerk.getDifficulty() - 1])
        feedBackLabel.setText(theorieAufgabe.datenSenden(sendParameter));
      else
        feedBackLabel.setText(rechenAufgabe.datenSenden(sendParameter));
    }
  }
  public void setButtons(int index)
  {
    int th_r = 0;
    if(aufg_Art[netzwerk.getDifficulty()-1])
    {
      showSolution.setVisible(false);
      th_r = 0;
    }
    else
    {
      showSolution.setVisible(true);
      th_r = 1;
    }
    if(buttons[th_r][index][0])
    {
      aufgabeErzeugen.setForeground(Color.BLACK);
    }
    else{
      aufgabeErzeugen.setForeground(new Color(135,135,135,135));
    }
    aufgabeErzeugen.setEnabled(buttons[th_r][index][0]);
    eingabeÜbernehmen.setEnabled(buttons[th_r][index][1]);
    testen1.setEnabled(buttons[th_r][index][2]);
    senden1.setEnabled(buttons[th_r][index][3]);
    start.setEnabled(buttons[th_r][index][4]);
    pause.setEnabled(buttons[th_r][index][5]);
    weiter.setEnabled(buttons[th_r][index][6]);
    stop.setEnabled(buttons[th_r][index][7]);
    moveUp.setEnabled(buttons[th_r][index][8]);
    moveDown.setEnabled(buttons[th_r][index][9]);
    delete.setEnabled(buttons[th_r][index][10]);
    stationen.setEnabled(buttons[th_r][index][11]);
    aktionen.setEnabled(buttons[th_r][index][12]);
    mitPrio.setEnabled(buttons[th_r][index][13]);
    mitReserv.setEnabled(buttons[th_r][index][14]);
    eingabeTextField.setEditable(buttons[th_r][index][15]);
    showSolution.setEnabled(buttons[th_r][index][16]);
    if(buttons[th_r][index][18])
      southCenterList.setBackground(Color.WHITE);
    else
      southCenterList.setBackground(Color.LIGHT_GRAY);
    if(netzwerk.getDifficulty() < 5 && !aufg_Art[netzwerk.getDifficulty()-1])
    {
      start.setEnabled(false);
    }
  }
}

class MainFrame_jMenuFileExit_ActionAdapter
    implements ActionListener {
  MainFrame adaptee;

  MainFrame_jMenuFileExit_ActionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class MainFrame_jMenuHelpAbout_ActionAdapter
    implements ActionListener {
  MainFrame adaptee;

  MainFrame_jMenuHelpAbout_ActionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.dialog.setModal(true);
    adaptee.dialog.show();

    adaptee.jMenuHelpAbout_actionPerformed(e);
  }

}