
import java.util.*;
/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

class Netzwerk {

  private LinkedList stationen;
  private Rahmen rahmen;
  private LinkedList verbindungen;
  private LinkedList sendeStationen;
  private int totalSize;
  private int übertragGeschwind;
  private int difficulty;
  private TimerGlobal Timer;
  private Vector aktionen;
  //Globale PDUqueue mit allen PDU's, die Stationen zu versenden haben,
  //notwendig für die Anzhal der Durchläufe für den TokenRingManager
  private LinkedList globalPDUQueue;

  public Netzwerk() {
    stationen = new LinkedList();
    verbindungen = new LinkedList();
    sendeStationen = new LinkedList();
    globalPDUQueue = new LinkedList();
    aktionen = new Vector();
    rahmen = new Rahmen(true);
  }

  public int getTotalSize()
  {
    totalSize = 0;
    for (Iterator i = verbindungen.iterator(); i.hasNext();)
    {
      Verbindung v = (Verbindung) i.next();
      totalSize += v.getSize();
    }
    return totalSize;
  }

  public void addStation(Station station)
  {
    stationen.add(station);
  }
  public LinkedList getStationenListe()
  {
    return stationen;
  }
  public void addVerbindung(Verbindung verbindung)
  {
    verbindungen.add(verbindung);
  }
  public LinkedList getVerbindungenListe()
  {
    return verbindungen;
  }
  public void addSendeStation(Station station)
  {
    sendeStationen.add(station);
  }
  public LinkedList getSendeStationenListe()
  {
    return sendeStationen;
  }
  public Rahmen getRahmen()
  {
    return rahmen;
  }
  public void setÜbertragGeschwind(int übertrag_Geschwind)
  {
    this.übertragGeschwind = übertrag_Geschwind;
  }
  public int getÜbertragGeschwind()
  {
    return übertragGeschwind;
  }
  public void addPDU(PDU pdu)
  {
    this.globalPDUQueue.add(pdu);
  }
  public LinkedList getGlobalPDUqueue()
  {
    return globalPDUQueue;
  }
  public void startTimer()
  {
    Timer = new TimerGlobal();
  }
  public TimerGlobal getTimer()
  {
    return Timer;
  }
  public void setDifficulty(int difficulty)
  {
    this.difficulty = difficulty;
  }
  public int getDifficulty()
  {
    return difficulty;
  }
  public Vector getAktionen()
  {
    return aktionen;
  }
  public void setAktionen(String aktion)
  {
    aktionen.add(aktion);
  }
}