import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class OnlineHilfeDialog
    extends JDialog {
  MainFrame mainFrame;
  public OnlineHilfeDialog(MainFrame mainFrame) throws HeadlessException {
    this.mainFrame = mainFrame;
    JPanel contentPane = (JPanel) getContentPane();
    contentPane.setLayout(new BorderLayout());
    try {
      URL u =
        new URL(mainFrame.tokenRingTrainer.getDocumentBase(),
        //MainFrame.class.getResource(
        "onlineHilfe.html");
      JEditorPane edit = new JEditorPane(u);
      edit.addHyperlinkListener(new OnlineHilfeHyperLinkListener(edit));
      edit.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
      JScrollPane scroll = new JScrollPane(edit);
      edit.setEditable(false);
      contentPane.add(scroll, BorderLayout.CENTER);
    }
    catch (IOException io) {
      contentPane.add(new Label("Could not load onlineHelp.html"), BorderLayout.CENTER);
    }
    JButton close = new JButton("Close");
    close.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        dispose();
      }
    });
    JPanel south = new JPanel();
    south.add(close);
    contentPane.add(south, BorderLayout.SOUTH);
    setSize(new Dimension(600, 600));
  }

}
