import java.math.BigDecimal;
/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/* Diese Timer-Klasse enthält die Zeit, in der ein Aufgabenszenario abgeschlossen
 * wird. Jede Station im Ring aktualisiert den Timer, wenn sie einen Rahmen oder
 * ein Token empfängt. Die letzte Aktualisierung entspricht dann dem Resultat.
 */
public class TimerGlobal {

  private float anfangsZeitPunkt = 0.0f;
  private float aktuelleZeit = 0.0f;
  private float endZeitPunkt = 0.0f;

  public TimerGlobal() {
  }

  public float getCurrentTime()
  {
    BigDecimal bd = new BigDecimal(aktuelleZeit);
    bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
    aktuelleZeit = bd.floatValue();
    return aktuelleZeit;
  }
  public void updateCurrentTime(float time)
  {
    BigDecimal bd = new BigDecimal(time);
    bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);

    aktuelleZeit += bd.floatValue();
  }
/*  public void setEndZeitPunkt(double endZeitPunkt)
  {
    this.endZeitPunkt. = endZeitPunkt;
  }
*/
public float getEndZeitPunkt()
  {
    return endZeitPunkt;
  }
  public float getAnfangsZeitPunkt()
  {
    return anfangsZeitPunkt;
  }
}