import java.math.BigDecimal;
/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

class Verbindung {

  private int laenge_m;
  private int laenge_bit;
  private float laenge_sec;
  private Station Anfangsstation, Endstation;
  private Rahmen rahmen;
  private float sendeZeitpunkt, empfangsZeitpunkt;

  public Verbindung(int size, Station Anfangsstation, Station Endstation) {
    this.Anfangsstation = Anfangsstation;
    this.Endstation = Endstation;
    laenge_m = size;
    laenge_sec = (size/2)*0.00001f; //hier: [ms], sonst 0.00000001 [s]
    laenge_bit = size/(200/Anfangsstation.getNetzwerk().getÜbertragGeschwind());
  }

  public int getSize()
  {
    return laenge_m;
  }
  public Station getAnfangsstation()
  {
    return Anfangsstation;
  }
  public Station getEndstation()
  {
    return Endstation;
  }
  public Rahmen getFrame()
  {
    return rahmen;
  }
  public void setFrame(Rahmen rahmen)
  {
    this.rahmen = rahmen;
  }
  public void delieverFrame()
  {
    try{
      empfangsZeitpunkt = Anfangsstation.getNetzwerk().getTimer().getCurrentTime();
      sendeZeitpunkt = empfangsZeitpunkt + laenge_sec;
      Anfangsstation.getNetzwerk().getTimer().updateCurrentTime(laenge_sec);
      System.out.println("Auf der Verbindung: "+Anfangsstation.getNetzwerk().getTimer().getCurrentTime());
      rahmen.setPosition(Endstation);
    }
    catch(NullPointerException e)
    {
    }

  }
}