
/**
 * Title:        Viror.teach.anim.net<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Ralf Gitzel<p>
 * Company:      Wifo III<p>
 * @author Ralf Gitzel
 * @version 1.0
 */
package gitzel.util;

/** an object of this type is passed to all TableErrorListeners when there is
 *  some irregularity with a TableGUI object. The reasoning behind this is
 *  the following; the table might be employed anywhere and the reaction to
 *  such an event might range from a beep to opening a new window. */
public class TableError
{

public final String Message;

public TableError(String message)
  {
  Message = message;
  }

public String getMessage()
  {
  return Message;
  }

}