


package gitzel.util;

import java.io.*;
import java.util.*;

/** This class contains a few utility methods for reading text. The most basic
 *  is getLines(InputStream in) which returns the content of the document as
 *  String[].
 * Copyright:    Copyright (c) Ralf Gitzel<p>
 * Company:      Wifo III<p>
 * @author Ralf Gitzel
 * @version 1.0
 */
public abstract class TextReader
{

public static String[] getLines(InputStream in) throws IOException
  {
  BufferedReader rin = new BufferedReader(new InputStreamReader(in));
  List l = new LinkedList();
  String ln = null;
  while(true)
    {
    ln = rin.readLine();
    if (ln == null) break;
    l.add(ln);
    }
  String[] ret = new String[l.size()];
  Iterator it = l.iterator();
  for(int i=0; i < l.size(); i++)
    {
    ret[i] = (String) it.next();
    }
  return ret;
  }

}