

package viror.teach.anim.net;

import javax.swing.*;
import java.awt.BorderLayout;
import java.beans.PropertyChangeListener;
import viror.teach.anim.UndoCustomizer;

/**
 * This rather simple customizer is for the OrnamentalComponent class
 * @author Ralf Gitzel
 * @version 1.0
 */
public class OrnamentalComponentCustomizer extends JPanel implements UndoCustomizer
{

  /** The text field where the decription is displayed */
  JTextArea Description;

  /** The OrnamentalComponent behind this customizer instance */
  OrnamentalComponent Data;

  /** The test saved to make undo possible */
  String UText;

  /** Is this customizer editable or not? */
  boolean Editable;

  public OrnamentalComponentCustomizer(boolean edit)
  {
  setLayout(new BorderLayout());
  Editable = edit;
  Description = new JTextArea();
  add(Description, BorderLayout.CENTER);
  }

  public void undo()
  {
  Data.setDescription(UText);
  }

  public void setObject(Object bean)
  {
  Data = (OrnamentalComponent) bean;
  UText = Data.getDescription();
  Description.setText(UText);
  }

  public void addPropertyChangeListener(PropertyChangeListener listener)
  {
    //TODO: Implement this java.beans.Customizer method
  }

  public void removePropertyChangeListener(PropertyChangeListener listener)
  {
    //TODO: Implement this java.beans.Customizer method
  }
}