import java.util.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/*
 * Die Eingabe des Anwenders als Lösung für Theorieaufgaben sowie die korrekte Lösung
 * werden in Gruppen aufgeteilt: für jeden neuen Schritt im Ablauf wird eine neue Gruppe
 * angelegt, d.h. eine Station nimmt eine best. Aktion vor, dann wird eine neue AktionenGruppe
 * erzeugt, wenn diese Station mehrere Aktionen am Stück durchführt, werden diese zu
 * derselben Gruppe hinzugefügt.
 */
public class AktionenGruppe {
  Vector aktionenSt = new Vector();          //aktionen
  Vector loesungRichtig = new Vector();      //wenn der Eintrag vom User einem
                                             //aus der Lösungsgruppe entspricht, wird dieser markiert
  Vector vergleich = new Vector();           //Initial auf 0 (später zur Ausgabe im JList)
  Vector indexEingabeBeiTrue = new Vector(); //Index der entsprechenden eingabeZeile bei richtig
  /* alle sind gleich lang*/
  String station;

  boolean gruppenWechsel = false;
  public AktionenGruppe() {
  }

  public boolean initialisiereAktionen(String aktion, boolean loesung) {
    /*
     Liefert true, wenn das anlegen geklappt hat
     Liefert false, wenn eine andere Station dazukam
     */
    if (aktionenSt.isEmpty()) {
      station = aktion.substring(0, 1);
      aktionenSt.add(aktion);
      System.out.println("Neue Gruppe " + station + ": " + aktion);
      loesungRichtig.add(new Boolean(false));
      if(loesung)
        vergleich.add(new Integer(3)); //die Lösungsliste mit "neutralen"(schwarzen) Werten füllen
      else
        vergleich.add(new Integer(0)); //die Eingabeliste mit neutralen Werten füllen
      indexEingabeBeiTrue.add(new Integer(100)); //100 hat keine Bedeutung, nur so als genügend großer Index
      return true;
    }
    else {
      if (aktion.substring(0, 1).equals(station)) {
        aktionenSt.add(aktion);
        System.out.println("Gruppe " + station + ": " + aktion);
        loesungRichtig.add(new Boolean(false));
        if(loesung)
          vergleich.add(new Integer(3));
        else
          vergleich.add(new Integer(0));
        indexEingabeBeiTrue.add(new Integer(100));
        return true;
      }
      else {
        return false;
      }
    }

  }

  public int checkEingabeGruppe(String eingabe, int x) throws theorieEingabeException {
    Iterator it = aktionenSt.iterator();
    int index = 0;
    while (it.hasNext()) {
      if (!eingabe.substring(0, 1).equals(station)) {
        //testen Gruppe +/-1
        throw new theorieEingabeException(1);
      }
      else {
        if(aktionenSt.isEmpty())
          throw new theorieEingabeException(1);
        String aktion = (String) it.next();
        if (aktion.equals(eingabe)) {
          if ( ( (Boolean) loesungRichtig.get(index)).booleanValue()) {
            throw new theorieEingabeException(2);
          }
          else {
            loesungRichtig.set(index, new Boolean(true));
            vergleich.set(index, new Integer(1));
            indexEingabeBeiTrue.add(index, new Integer(x));
            return 1;
          }
        }
        else {
        }
        index++;
      }
    }
    throw new theorieEingabeException(3);
  }
  public void leereGruppeErzeugen(String station)
  {
    this.station = station;
  }
}