
import java.util.*;
/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class AufgabeErzeugen {

  //int difficulty = 0;
  Netzwerk newNet = null;
  LinkedList Stationen_Verbindungen = new LinkedList();
  int übertragGeschwind;
  int [] min_Anz_Stationen = {3,3,3,3,3,4,4,4,4,5,5,5,4,4,5,5,5,5,5,6,6,6,6,6,6,6};
  int [] max_Anz_Stationen = {0,0,6,1,1,1,1,1,1,1,1,1,0,0,1,1,2,2,3,3,4,4,5,5,6,6};
  int [] übertrag_Geschwind = {10,10,10,10,10,4,4,4,4,16,16,16,4,4,16,16,16,16,16,16,16,16,16,16,16,16};
  int [] schwierig_Niveau = {1,1,1,1,1,2,2,3,3,4,4,4,5,5,6,6,6,6,6,7,7,7,7,7,7,7};
  boolean t = true, r = false;
  boolean [] aufg_Art = {t,r,r,t,r,t,r,t,r,t,r,r,t,r,t,r,t,r,t,r,t,r,t,r,t,r};
  public AufgabeErzeugen() {
  }

  public Netzwerk erzeugeNetz(int difficulty, boolean monitoring, boolean priority)
  {
    /* ******************* Stationen erzeugen ************************ */
    int anz_Stationen = 0;
    Random r = new Random();

    System.out.println("Anzahl der Stationen von "+min_Anz_Stationen[difficulty-1]+" bis "+(min_Anz_Stationen[difficulty-1]+(max_Anz_Stationen[difficulty-1])));

    if(difficulty == 3) anz_Stationen = 4 + Math.abs(r.nextInt(7));
    else
    {
      if (max_Anz_Stationen[difficulty-1]==0)
        anz_Stationen = min_Anz_Stationen[difficulty-1];
      else
        anz_Stationen = min_Anz_Stationen[difficulty-1] + Math.abs(r.nextInt(max_Anz_Stationen[difficulty-1]));
    }
    übertragGeschwind = übertrag_Geschwind[difficulty-1];

    System.out.println("Anzahl Stationen "+anz_Stationen);

    newNet = new Netzwerk();

    char buchstabe = 'A';

    for (int i = 0; i < anz_Stationen; i++)
    {
      Station station = new Station(newNet);
      newNet.addStation(station);
      Stationen_Verbindungen.add(station);
      station.setName(""+buchstabe);
      buchstabe++;
    }
    /* ************** Verbindungen zwischen Stationen ************** */

    erzeugeVerbindungen(newNet);
    System.out.println("Gesamtlänge des Ringes "+newNet.getTotalSize());

    /* ************** Aktiven Monitor auswählen ******************** */

    int ActivMonitorIndex = Math.abs(r.nextInt(anz_Stationen));
    Station activMonitor = (Station)newNet.getStationenListe().get(ActivMonitorIndex);
    activMonitor.setActivMonitor(true);
    System.out.println("Der aktive Monitor: "+activMonitor.getName());

    /* *************  ****************/

    boolean tokenPassingFails = false;
    if(difficulty-1 > 6 && difficulty-1 < 12)
    {
      tokenPassingFails = true;
    }
    else
    {
      if(difficulty-1 > 14)
      {
        tokenPassingFails = (r.nextInt(2) == 1 ? true : false);
        System.out.println("RP " +(tokenPassingFails ? "wird eingebaut":"wird nicht eingebaut"));
      }
    }

    /* ************** Sender-Stationen festlegen ******************** */

    Vector hilfsIndizes = new Vector();
    for (int i = 0; i < anz_Stationen; i++)
    {
      hilfsIndizes.add(new Integer(i));
    }
    int anz_SendeStationen = 2 + Math.abs(r.nextInt())%(anz_Stationen/2 + 1);//ändern
    System.out.println("Anzahl der sendewilligen Stationen "+anz_SendeStationen);
    int indexZufall, indexInhalt;
    for(int i = 0; i < anz_SendeStationen; i++)
    {
      indexZufall = Math.abs(r.nextInt(hilfsIndizes.size()));
      indexInhalt = ((Integer)hilfsIndizes.remove(indexZufall)).intValue();
      Station sendeStation = (Station)newNet.getStationenListe().get(indexInhalt);
      newNet.addSendeStation(sendeStation);

      int anz_PDU = Math.abs(r.nextInt());
      int prioritaet = 0;
      if(difficulty-1 > 11)
      {
        priority = true;
      }

      int groesse = 0;
      switch(übertragGeschwind)
      {
        case 4: groesse = 4000; //5000
        case 10: groesse = 11000; //12500
        case 16: groesse = 18000; //20000
      }
      int n = 1 + Math.abs(r.nextInt(schwierig_Niveau[difficulty-1]));
      System.out.println("Position in der Queue der Sendestationen "+i+" Station: "+sendeStation.getName());
      for (int j = 0; j < n;)
      {
        int indexZufall2 = Math.abs(r.nextInt(newNet.getStationenListe().size()));
        Station zielStation = (Station)newNet.getStationenListe().get(indexZufall2);
        if(sendeStation != zielStation)
        {
          if(priority)
          {
            prioritaet = Math.abs(r.nextInt(7));
          }
          PDU pdu = new PDU(groesse, prioritaet, zielStation, sendeStation);
          sendeStation.addPDU(pdu);
          System.out.println(j+". PDU mit Prio " +prioritaet+" an "+zielStation.getName());
          j++;
        }
      }
    }
    if (tokenPassingFails)
    {
      int indexZufallRP = Math.abs(r.nextInt(newNet.getStationenListe().size()));
      Station stationFehlerImTokenPassing = (Station)newNet.getStationenListe().get(indexZufallRP);
      System.out.println(stationFehlerImTokenPassing.getName()+": wird einen Fehler einbauen");
      int indexZufallRPPDU = Math.abs(r.nextInt(stationFehlerImTokenPassing.getPDUQueue().size()));
      PDU pduRP = (PDU)stationFehlerImTokenPassing.getPDUQueue().get(indexZufallRPPDU);
      pduRP.setFehler(true);
      System.out.println("PDU Nr "+indexZufallRPPDU+" adressiert an: "+pduRP.getDestinationStation().getName());
    }

    /* *************** Position des Token festlegen *************** */
    Rahmen token = newNet.getRahmen();
    if(aufg_Art[difficulty-1])
    {
      int tokenPosition = Math.abs(r.nextInt(Stationen_Verbindungen.size()));
      token.setPosition(Stationen_Verbindungen.get(tokenPosition));
     // newNet.startTimer();
     if(token.getPosition() instanceof Verbindung)
     {
       ((Verbindung)token.getPosition()).setFrame(token);
        System.out.println("Token ist zwischen " +
                           ( (Station) ( (Verbindung) token.getPosition()).
                             getAnfangsstation()).getName() +
                           " und " +
                           ( (Station) ( (Verbindung) token.getPosition()).
                             getEndstation()).getName());
      }
      else
      {
        ((Station)token.getPosition()).setFrame(token);
        System.out.println("Token ist bei " +
                           ( (Station) token.getPosition()).getName());
      }
    }
    else
    {
      int tokenPosition = Math.abs(r.nextInt(newNet.getStationenListe().size()));
      token.setPosition(newNet.getStationenListe().get(tokenPosition));
      ((Station)token.getPosition()).setFrame(token);
      System.out.println("Token ist bei "+((Station)token.getPosition()).getName());
    }

    return newNet;
  }

  public int erzeugeVerbindung_Laenge()
  {
    int laenge = 0;
    Random r = new Random();
    laenge = 500 + 100*Math.abs(r.nextInt(6));
    return laenge;
  }

  public void erzeugeVerbindungen(Netzwerk netzwerk)
  {
    int anz_Verbindungen = netzwerk.getStationenListe().size();   //Verbindungen zwischen Stationen, Beziehungen zwischen Stationen
    int laenge = erzeugeVerbindung_Laenge();
    System.out.println(laenge);
    for (int i = 0; i < anz_Verbindungen; i++)
    {
      Station endStation = null;
      if(i == anz_Verbindungen - 1)
      {
        endStation = (Station)netzwerk.getStationenListe().getFirst();
      }
      else
      {
        endStation = (Station)netzwerk.getStationenListe().get(i+1);
      }
      Station anfangsStation = (Station)netzwerk.getStationenListe().get(i);
      Verbindung verbindung = new Verbindung(laenge, anfangsStation, endStation);
      anfangsStation.setDownstreamConnection(verbindung);
      endStation.setUpstreamConnection(verbindung);
      anfangsStation.setSuccessor(endStation);
      endStation.setPredecessor(anfangsStation);

      netzwerk.addVerbindung(verbindung);
      Stationen_Verbindungen.add(verbindung);
      /* ***************************** */
    }

  }
  public static void main(String[] args)
  {
    AufgabeErzeugen erzeuge = new AufgabeErzeugen();
    Netzwerk netzwerk = erzeuge.erzeugeNetz(16, false, false);
    TokenRingManager tokenRingThread = new TokenRingManager (netzwerk);
    tokenRingThread.start();
  }
}