
import javax.swing.ListCellRenderer;
import java.awt.Component;
import javax.swing.JList;
import javax.swing.*;
import java.awt.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/* Diese Klasse ist für die Darstellung der JList-Einträge zuständig.
 * Die korrigierte Eingabe des Anwenders wird rot, grün oder schwarz angezeigt.
 */
public class EingabeListCellRenderer extends JLabel
    implements ListCellRenderer {

  int[] testArray = null;
  boolean test = false;
  boolean richtig = false;

  public EingabeListCellRenderer() {
    setOpaque(true);
  }

  public void paint (Graphics g) {
    super.paint(g);
    if (getForeground() == Color.RED) {
      g.setColor(Color.RED);
      g.drawLine(0,getHeight()/2,getWidth(),getHeight()/2);
    }
  }

  public Component getListCellRendererComponent(JList list, Object value,
                                                int index, boolean isSelected,
                                                boolean cellHasFocus) {
//    if(testArray != null)
    if(test)
    {
      // 1 = ok, eingabe == loesung
      // 2 = falsch, eingabe != loesung
      // 3 = richtige Lösung, eingabe fehlt
      int i = testArray[index];
      switch (i)
      {
      case 1:
        setBackground(isSelected ? Color.BLUE : Color.WHITE);
        setForeground(isSelected ? Color.WHITE : Color.GREEN);
        setText((String) value);
        break;
      case 2:
        setBackground(isSelected ? Color.BLUE : Color.WHITE);
        setForeground(Color.RED);
        setText((String) value);
        break;
      case 3:
        setBackground(isSelected ? Color.BLUE : Color.WHITE);
        setForeground(Color.BLACK);
        setText((String) value);
        break;
      }
    }
    else
    {
      setBackground(isSelected ? Color.BLUE : Color.WHITE);
      setForeground(isSelected ? Color.WHITE : Color.BLACK);
      setText((String) value);
    }
    return this;
  }

  public void setTestArray(int [] testArray) {
    this.testArray = testArray;
  }
  public void setTest(boolean test)
  {
    this.test = test;
  }
  public void setRichtig(boolean richtig)
  {
    this.richtig = richtig;
  }
}