

package viror.teach.anim.net;

import java.awt.*;
import javax.swing.*;
import java.net.*;
import java.io.IOException;
import gitzel.util.*;

/** This class does not have any functionality beyond that of SoftwareComponent
 *  but has as long descriptive text plus a rather simplistic Customizer (which
 *  does not deserve that name really....) */
public class OrnamentalComponent extends SoftwareComponent
{

public OrnamentalComponent(Image basic, Image selected)
  {
  this(basic, selected, 0, 0);
  }

public OrnamentalComponent(Image basic, Image selected, int x, int y)
  {
  super(basic, selected, x, y);
  }

/** Fills the description from a document lying on the server. The format should
 *  be like this:
 *  N: server name
 *  D: line of description
 *  D: next line
 *  D: ....
 */
public void initFromURL(URL data) throws IOException, NumberFormatException
  {
  IniReader i = new IniReader(data.openStream());
  setDescription(i.getEntry("D"));
  setName(i.getEntry("N"));
  }

public JComponent getCustomizer(boolean edit)
  {
  OrnamentalComponentCustomizer cuss = new OrnamentalComponentCustomizer(edit);
  cuss.setObject(this);
  return cuss;
  }


}